Attribute VB_Name = "McrTime"
Option Explicit

'-----------------------------------------------------------------------------
'
' Data types used for accessing DLL functions
'
Enum MCT_TIME_REF
    RT_NONE
    RT_GPS
    RT_OBC
End Enum

Enum MCT_FIX_TYPE
    FT_NONE
    FT_2D
    FT_3D
End Enum

Enum MCT_FIX_QUALITY
    FQ_NONE
    FQ_NONDIFF
    FQ_DIFF
    FQ_ESTIMATED
End Enum

Public Type LARGE_INTEGER
    LowPart          As Long
    HighPart         As Long
End Type

Public Type MCT_VERSION
    major            As Long
    minor            As Long
    revision         As Long
    build            As Long
End Type

Public Type MCT_CHECKSUM
    value            As Long
End Type

Public Type MCT_HW_STATUS
    hasGPS           As Byte
    hasOBC           As Byte
    activeReference  As MCT_TIME_REF
    gpsFixType       As MCT_FIX_TYPE
    gpsFixQuality    As MCT_FIX_QUALITY
    gpsStatusFlags   As Long
    gpsTemperature   As Long
    heartBeat        As Long
End Type

Public Type MCT_SIGNAL_QUALITY
    satsInView       As Long
    satsInUse        As Long
    PRN(1 To 12)     As Long
    SNR(1 To 12)     As Long
End Type

Public Type MCT_POSITION
    latDegrees       As Long
    latMinutes       As Double
    latPolarity      As Long
    '
    lgtDegrees       As Long
    lgtMinutes       As Double
    lgtPolarity      As Long
    '
    altitude         As Double
    speed            As Double
    course           As Double
End Type

Public Type MCT_SETTABLE_TIME
    year             As Long
    month            As Long
    day              As Long
    hour             As Long
    minute           As Long
    seconds          As Long
    millisec         As Long
End Type

Public Type MCT_TIME
    year             As Long
    month            As Long
    day              As Long
    hour             As Long
    minute           As Long
    seconds          As Long
    millisec         As Long
    leapsecs         As Long
    timestamp        As LARGE_INTEGER
End Type


'-----------------------------------------------------------------------------
'
' DLL API functions
'
Declare Function McrGetDriverVersion _
        Lib "mcrtime.dll" _
        (ByRef version As MCT_VERSION) As Long

Declare Function McrGetFwVersion _
        Lib "mcrtime.dll" _
        (ByRef version As MCT_VERSION) As Long

Declare Function McrGetFwChecksum _
        Lib "mcrtime.dll" _
        (ByRef checksum As MCT_CHECKSUM) As Long

Declare Function McrGetHwSignature _
        Lib "mcrtime.dll" _
        (ByVal signature As String, ByVal size As Long) As Long

Declare Function McrGetHwStatus _
        Lib "mcrtime.dll" _
        (ByRef status As MCT_HW_STATUS) As Long

Declare Function McrGetSignalQuality _
        Lib "mcrtime.dll" _
        (ByRef sq As MCT_SIGNAL_QUALITY) As Long

Declare Function McrGetPosition _
        Lib "mcrtime.dll" _
        (ByRef position As MCT_POSITION) As Long

Declare Function McrGetTime _
        Lib "mcrtime.dll" _
        (ByRef time As MCT_TIME) As Long

Declare Function McrSetTime _
        Lib "mcrtime.dll" _
        (ByRef time As MCT_SETTABLE_TIME) As Long


